#!/usr/bin/python3
import time,serial,math		#uporabljene funkcije
rxime='/dev/ttyUSB1'		#ime zaporednega vmesnika sprejemnika
vrtime='/dev/ttyUSB0'		#ime zaporednega vmesnika vrtiljaka
meritev=bytes('6D','utf-8')	#hitrost meritve
povratek=bytes('8L','utf-8')	#hitrost povratka

print('*** Meritev in prikaz smernega diagrama - S53MV 16.10.2021 ***')
x=[]			#polji za rezultat
y=[]
ff=input('Ime zapisa (prazno=nova meritev): ')
if len(ff)==0:		#nova meritev
	nn=input('Naslov: ')
	i=0			#3601 vrstic podatkov: kot+jakost
	while i<=3600:
		x+=[i*0.1]
		y+=[99.99]	#99.99 za javljanje napake
		i+=1
	#odpri comporta rx in vrt, 115200bps, 8bit, brez paritete
	print('Počakaj na lenobni USB...')
	rx=serial.Serial(rxime,115200,timeout=3.0)
	rx.setRTS(False)	#sprosti /BOOTLOADER
	rx.setDTR(False)	#sprosti /RESET
	vrt=serial.Serial(vrtime,115200,timeout=3.0)
	vrt.setRTS(False)	#sprosti /BOOTLOADER
	vrt.setDTR(False)	#sprosti /RESET
	time.sleep(3)
	vrt.flushInput()	#počisti sprejemni vmesnik vrtiljaka
	vrt.write(meritev)	#meritev z vrtiljakom
	i=0			#zanka merjenja antene
	while i<3600:
		s=vrt.readline()
		k=float(s)
		rx.flushInput()
		rx.readline()
		s=rx.readline()
		r=float(s)
		print('Kot:%6.1f'%k+' Jakost:%6.2f'%r+'dB    ',end='\r')
		i=int(k*10.0+0.5)
		y[i]=r
	vrt.write (povratek)	#povratek vrtiljaka
	t=time.ctime()		#zabelezi čas meritve
	f=t[20:24]+t[4:7]+t[8:10]+t[11:13]+t[14:16]+t[17:19]+'.csv'	#ime izhodnega zapisa
	print('\nMeritev v zapis: '+f)
	iz=open(f,'w')		#shrani izmerjene podatke v izhodni zapis
	iz.write(t+'\n')	#prva vrstica: čas meritve
	iz.write(nn+'\n')	#druga vrstica: naslov meritve
	i=0			#3601 vrstic podatkov: kot+jakost
	while i<=3600:
		iz.write('%5.1f'%(x[i])+' %5.2f'%(y[i])+'\n')
		i+=1
	iz.close()		#zapri izhodni zapis
	rx.close()		#zapri oba comporta
	vrt.close()
else:				#preberi podatke iz vhodnega zapisa
	vz=open(ff,'r')
	s=vz.readline()		#prva vrstica: čas meritve
	t=s[:-1]
	s=vz.readline()		#druga vrstica: naslov meritve
	nn=s[:-1]
	i=0			#3601 vrstic podatkov: kot+jakost
	while i<=3600:
		s=vz.readline().split()
		k,r=float(s[0]),float(s[1])
		x+=[k]
		y+=[r]
		i+=1
	vz.close()		#zapri vhodni zapis
### skupni izpis rezulatov in risanje diagramov ###
print(nn+' '+t)		#izpiši naslov in čas meritve
m=-1			#išči maksimum m
i=0
while i<=3600:
	if y[i]>m:
		m=y[i]
		km1=x[i]
	if y[i]==m:
		km2=x[i]
	i+=1
i=0			#normaliziraj smerni diagram na max in lin skala yl
yl=[]
while i<=3600:
	y[i]=y[i]-m
	yl=yl+[math.pow(10.0,y[i]*0.05)]
	i+=1
km=(km1+km2)*0.5	#srednji kot maksimuma s popravki
if km2-km1>180:
	km+=180
if km>360:
	km-=360
i=int(km*10+0.5)	#poišči spodnjo mejo -3dB
j=3600
while j>0:
	if i<0:
		i+=3600
	km1=i*0.1
	if y[i]<-3.0:
		j=0
	i-=1
	j-=1
i=int(km*10+0.5)	#poišči gornjo mejo -3dB
j=3600
while j>0:
	if i>3600:
		i-=3600
	km2=i*0.1
	if y[i]<-3.0:
		j=0
	i+=1
	j-=1
alfa=km2-km1		#preskok 360 stopinj?
if alfa<0:
	alfa+=360
i=1			#integriraj smerni diagram
s=0.0
im=int(km*10+0.5)
while i<1800:
	i1=im-i
	if i1<0:
		i1=i1+3600
	i2=im+i
	if i2>3600:
		i2=i2-3600
	ff=math.pow(10,(y[i1]*0.1))+math.pow(10,(y[i2]*0.1))
	s+=ff*math.sin(math.radians(i*0.1))
	i+=1
D=(7200/math.pi)/s	#izračunaj smernost
smernost='Max:%5.1f'%m+'dB    Odklon:%6.1f'%(km-180.0)+'°    Sirina-3dB:%6.1f'%alfa+'°    '
smernost+='Smernost: %5.1f'%(D)+' = %5.2f'%(10*math.log(D,10))+'dBi'
print(smernost)
j=1	#risanje smernega diagrama na različne načine
while j>0:
	j=int(input('Izberi diagram (1=k.log, 2=k.lin, 3=p.log, 4=p.lin, 0=izhod): '))
	if j>0 and j<5:
		print('Počakaj na nalaganje grafike...')
		import matplotlib.pyplot as plt
	if j==1 or j==2:			#risanje v kartezičnih koordinatah?
		plt.plot([km,km],[-40,2],'y-')	#nariši položaj maksimuma in širino lista
		plt.plot([km1,km1],[-40,2],'r-')
		plt.plot([km2,km2],[-40,2],'r-')
		if j==1:
			plt.plot(x,y,'b-')	#nariši log smerni diagram
			plt.axis([0,360,-40,2])
			plt.yticks([-40,-35,-30,-25,-20,-15,-10,-5,0])
			plt.ylabel('Relativna jakost sprejema v dB')
		else:
			plt.plot(x,yl,'b-')	#nariši lin smerni diagram
			plt.axis([0,360,0,1.05])
			plt.yticks([0.0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0])
			plt.ylabel('Jakost sprejema (amplituda) v linearnem merilu')
		plt.xticks([0,45,90,135,180,225,270,315,360])
		plt.grid(True)
		plt.title(t+'\n'+nn)
		plt.xlabel(smernost)
		plt.show()
	if j==3 or j==4:			#risanje v polarnih koordinatah
		x1=[]	#priprava krogov in pretvorba podatkov
		y1=[]
		x2=[]
		y2=[]
		x3=[]
		y3=[]
		x4=[]
		y4=[]
		xx=[]
		yy=[]
		i=0
		while i<=3600:
			s=math.sin(math.radians(i*0.1))
			c=math.cos(math.radians(i*0.1))
			x1+=[s/4]
			y1+=[c/4]
			x2+=[s/2]
			y2+=[c/2]
			x3+=[3*s/4]
			y3+=[3*c/4]
			x4+=[s]
			y4+=[c]
			if j==3:
				a=(y[i]+40.0)/40.0	#logaritemsko merilo
				if a<0.0:
					a=0.0
			else:
				a=yl[i]			#linearno merilo
			xx+=[a*s]
			yy+=[-a*c]
			i+=1
		l=0.2			#nariši kroge koordinatne mreže
		plt.plot(x1,y1,'g-',lw=l)	#krog polmera 0.25
		plt.plot(x2,y2,'g-',lw=l)	#krog polmera 0.5
		plt.plot(x3,y3,'g-',lw=l)	#krog polmera 0.75
		plt.plot(x4,y4,'g-',lw=l)	#krog polmera 1
		k=0			#razdelki po 30 stopinj
		while k<360:
			xk=math.sin(math.radians(k))*0.25
			yk=math.cos(math.radians(k))*0.25
			plt.plot([0.0,xk],[0.0,yk],'g-',lw=l)
			k+=30
		k=0			#razdelki po 15 stopinj
		while k<360:
			xz=math.sin(math.radians(k))*0.25
			yz=math.cos(math.radians(k))*0.25
			xk=math.sin(math.radians(k))*0.5
			yk=math.cos(math.radians(k))*0.5
			plt.plot([xz,xk],[yz,yk],'g-',lw=l)
			k+=15
		k=0			#razdelki po 5 stopinj
		while k<360:
			xz=math.sin(math.radians(k))*0.5
			yz=math.cos(math.radians(k))*0.5
			xk=math.sin(math.radians(k))
			yk=math.cos(math.radians(k))
			plt.plot([xz,xk],[yz,yk],'g-',lw=l)
			k+=5
		r=1.03			#nariši položaj maksimuma in širino lista
		plt.plot([0,math.sin(math.radians(km))*r],[0,-math.cos(math.radians(km))*r],'y-')
		plt.plot([0,math.sin(math.radians(km1))*r],[0,-math.cos(math.radians(km1))*r],'r-')
		plt.plot([0,math.sin(math.radians(km2))*r],[0,-math.cos(math.radians(km2))*r],'r-')
		plt.plot(xx,yy,'b-')	#nariši smerni diagram
		plt.axis([-1.05,1.05,-1.05,1.05])
		plt.xticks([])
		plt.yticks([])
		plt.title(t+'\n'+nn)
		plt.xlabel(smernost)
		if j==3:
			plt.ylabel('Logaritemsko radialno merilo (razpon 40dB)')
		else:
			plt.ylabel('Linearno radialno merilo za jakost (amplituda)')
		plt.gca().set_aspect('equal')
		plt.show()
print('*** Konec programa ***')
